[PATCH] Makefile: add allow-list for failures

Florian Weimer fweimer@redhat.com
Mon Feb 23 13:02:31 GMT 2026


* Martin Coufal:

> Enable adding known failures to allowed-failures.txt and ignore failures
> in case they are in the list.  In case the allowed-failures.txt does not
> exist, all failures lead to a failed status as before.
>
> When the file is present, failures of listed tests are ignored and reported
> on stdout. If tests not in the allowed list fail, summarize-tests exits with
> status 1 and reports the failing tests.
>
> The expected format of allowed-failures.txt file is:
> <test_name> # <comment>
> ---
>  Makefile | 29 ++++++++++++++++++++++++++++-
>  1 file changed, 28 insertions(+), 1 deletion(-)
>
> diff --git a/Makefile b/Makefile
> index f81572c20a..f7a993f15b 100644
> --- a/Makefile
> +++ b/Makefile
> @@ -594,7 +594,34 @@ define summarize-tests
>  @grep -E '^[A-Z]+:' $(objpfx)$1 | grep -E -v '^(PASS|XFAIL):' || true
>  @echo "		=== Summary of results$2 ==="
>  @sed -e '/:.*/!d' -e 's/:.*//' < $(objpfx)$1 | sort | uniq -c
> -@! grep -E '^[A-Z]+:' $(objpfx)$1 | grep -E -q -v '^(X?PASS|XFAIL|UNSUPPORTED):'
> +@{ \
> +	grep -E '^[A-Z]+:' $(objpfx)$1 | \
> +	grep -E -v '^(X?PASS|XFAIL|UNSUPPORTED):' | \
> +	( \
> +	  if ! test -f $(..)allowed-failures.txt; then \
> +	    read -r _; exit $$(( $$? == 0 )); \

Can we use bash-only constracts in Makefiles?

I think you could turn this into

  read -r _; test $$? -ne 0

because it inverts the condition (exit status 0 if the read failed
because there are no failed tests).

Thanks,
Florian



More information about the Libc-alpha mailing list